/* eslint-disable */
import {
  Http, IDictionary, Metadata, Loader, Config,
} from '@zeedhi/core';
import {
  AlertService, DialogService, Image, FileInput, LoadingService, Button,
} from '@zeedhi/common';
import { Utilities } from '@/util/Utilities';


export class TabLogotypeController {

  public BPController = Loader.getInstance('BusinessPartnerController');

  public showImage({ component }: any) {
    const componentImage = Metadata.getInstance<Image>('image-logotype');

    if (component.value) { // tamanho do fileInput
      componentImage.src = window.URL.createObjectURL(component.value);
      componentImage.isVisible = true;
    } else {
      componentImage.isVisible = false;
    }
  }

  public async saveImage() {
    const img = await Utilities.buildArrayToUpload('FileInputl-imagens');
    LoadingService.show();
    Http.post('/sendImage', {
        NRPARCNEGOCIO: this.BPController.currentRow.NRPARCNEGOCIO,
        DSDIRLOGOMARCA: img,
    }).then((response) => {
        this.alertMessages('Logotipo salvo com sucesso!', 'success');
        Metadata.getInstance<Button>('deleteButtonLogotype').isVisible = true;
        Metadata.getInstance<Image>('image-logotype').src = Config.env.fileServerUrl+'/files/'+response.data.dataset.image[0];
        console.log(Metadata.getInstance<Image>('image-logotype'));
       // Metadata.getInstance<Image>('image-logotype').link = response.data.dataset.image[0];
    }).catch((error: any) => {
      Utilities.showErrorMessage(error);
    }).finally(() => {
      LoadingService.hide();
    });
  }

  public async deleteImage() {
    const img = Metadata.getInstance<Image>('image-logotype');
    LoadingService.show();
    Http.post('/deleteImage', {
        NRPARCNEGOCIO: this.BPController.currentRow.NRPARCNEGOCIO,
      //  LINK: img.link,
    }).then(() => {
        this.alertMessages('Logotipo excluida com sucesso!', 'success');
      //  img.link = null;
        img.src = '';
        Metadata.getInstance<Button>('deleteButtonLogotype').isVisible = false;
        LoadingService.hide();
    }).catch((error: any) => {
      Utilities.showErrorMessage(error);
      LoadingService.hide();
    });
  }

  public mountImages({ component }: any) {
    component.isVisible = true;
    LoadingService.show();
    Http.post('/getImage', {
        NRPARCNEGOCIO: this.BPController.currentRow.NRPARCNEGOCIO,
    }).catch((error: any) => {
      Utilities.showErrorMessage(error);

      LoadingService.hide();
    });
    LoadingService.hide();
  }

  public alertMessages(message: string, type: string) {
    AlertService.show({
      name: 'basic-alert',
      text: message,
      top: true,
      left: false,
      timeout: 3000,
      color: type,
    });
  }

  public dialogMessage(message: string) {
    DialogService.show({
      name: 'warning-dialog',
      type: 'warning',
      title: 'Erro!',
      text: message,
    });
  }
}
